package test;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Desktop;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.EventQueue;
import org.zkoss.zk.ui.event.EventQueues;
import org.zkoss.zk.ui.select.SelectorComposer;
import org.zkoss.zk.ui.select.Selectors;
import org.zkoss.zk.ui.select.annotation.Wire;
import org.zkoss.zk.ui.util.DesktopCleanup;
import org.zkoss.zul.Hlayout;
import org.zkoss.zul.Label;
import org.zkoss.zul.Script;

public class MyComposer extends SelectorComposer<Component> {

	
	static int count;
	
	private static synchronized int nextCount(){
		return ++count;
	}
	
	@Wire
	Hlayout hlayout;
	
	EventListener listener;
	
	@Override
	public void doAfterCompose(Component comp) throws Exception {
		// TODO Auto-generated method stub
		super.doAfterCompose(comp);
		
		EventQueue<Event> queue = EventQueues.lookup("test",EventQueues.APPLICATION,true);
		
		//register application for global scope
		queue.subscribe(listener = new EventListener<Event>(){
			public void onEvent(Event event) throws Exception {
				hlayout.appendChild(new Label((String)event.getData()));
			}
		});
		
		queue.publish(new Event("onNewAccess",null,"User "+ nextCount()));
		
		comp.getDesktop().addListener(new DesktopCleanup() {
			
			public void cleanup(Desktop desktop) throws Exception {
				
				
				//when desktop clean up, should unregister the queue, to release the queue -> listener -> composer -> deskotp reference  
				EventQueue<Event> queue = EventQueues.lookup("test",EventQueues.APPLICATION,false);
				if(queue!=null){
					queue.unsubscribe(listener);
				}
				
				System.out.println(">>>> done release "+desktop +";"+queue);
			}
		});
		
		String uri = comp.getDesktop().getDynamicMediaURI(comp, "/test.css");
		Script script = (Script)Selectors.find(getPage(), "#ss").iterator().next();
		uri = uri.substring(uri.indexOf('/', 1));//trim the context root
		System.out.println(">>>> uri "+uri);
		script.setSrc(uri);
	}
	
	

}
